*+
*+
*+    Source Module => CDX_LAST.PRG
*+
*+    Functions: Function Main()
*+               Function MakeTest()
*+               Function ShowIt()
*+
*+       Tables: use Test New
*+               use
*+               use test new
*+               use
*+
*+      Indexes: index on F1 tag one
*+
*+    Reformatted by Click! 1.11 on Sep-21-1997 at 11:13 pm
*+
*+

/*

A query on CIS re' dbseek() performance with last = .t. (_dbfcdx rdd)
induced me to put together the following to show results under
different scenarios. Conclusion - use last = .t. with caution.

Jo French

*/

#include "ORD.CH"
field F1
request _dbfcdx

*+
*+
*+    Function Main()
*+
*+
*+
function Main()

local nChoice := 0
local cSearch
local cSpace  := space( 10 )
local lAscend := .T.
local GetList := {}

rddsetdefault( "_dbfcdx" )
readexit( .t. )
cls
MakeTest()
use Test New
ordsetfocus( "one" )
while .t.
   cls
   @ 10, 10 say "Ascending" get lAscend picture "Y"       
   read
   If lastkey() == 27
      exit
   endif
   cls
   If lAscend
      Orddescend(,, .F. )
      @ 00, 28 say "ASCENDING ORDER"         
   else
      Orddescend(,, .T. )
      @ 00, 28 say "DESCENDING ORDER"         
   endif
   @ 01, 12 say "SoftSeek  Last  Exact Expr"         
   @ 02, 12 prompt "   Y        Y        Y    CCCCCCCCCC"
   @ 03, 12 prompt "   Y        N        Y    CCCCCCCCCC"
   @ 04, 12 prompt "   N        Y        Y    CCCCCCCCCC"
   @ 05, 12 prompt "   N        N        Y    CCCCCCCCCC"
   @ 06, 12 prompt "   Y        Y        N    BBBBBBBBBB"
   @ 07, 12 prompt "   Y        N        N    BBBBBBBBBB"
   @ 08, 12 prompt "   N        Y        N    BBBBBBBBBB"
   @ 09, 12 prompt "   N        N        N    BBBBBBBBBB"
   menu to nChoice
   If nChoice == 0
      exit
   endif
   If nChoice < 5
      cSearch := "CCCCCCCCCC"
   else
      cSearch := "BBBBBBBBBB"
   endif
   @ 10,  0 say ""         
   If lAscend
      list cSpace, F1, recno(), if( recno() > 8 .or. ;
                               recno() == 2, "*", " " ) off
   else
      list cSpace, F1, recno(), if( recno() < 3 .or. ;
                               recno() == 9, "*", " " ) off
   endif
   ? cSpace, "-----------------------"
   do case
   case nChoice == 1 .or. nChoice == 5
      ShowIt( lAscend, cSearch, .t., .t. )
   case nChoice == 2 .or. nChoice == 6
      ShowIt( lAscend, cSearch, .t., .f. )
   case nChoice == 3 .or. nChoice == 7
      ShowIt( lAscend, cSearch, .f., .t. )
   case nChoice == 4 .or. nChoice == 8
      ShowIt( lAscend, cSearch, .f., .f. )
   endcase
   inkey( 0 )
end
use

return Nil

*+
*+
*+    Function MakeTest()
*+
*+    Called from ( cdx_last.prg )   1 - function main()
*+
*+
*+
function MakeTest()

ferase( "test.cdx" )
dbcreate( "TEST", { { "F1", "C", 10, 0 } } )
use test new
while recno() < 10
   dbappend() 
   F1 := "CCCCCCCCCC"
end
go top
field->F1 := "EEEEEEEEEE"
go bott
field->F1 := "AAAAAAAAAA"
index on F1 tag one
use

return nil

*+
*+
*+    Function ShowIt()
*+
*+    Called from ( cdx_last.prg )   4 - function main()
*+
*+
*+
function ShowIt( lAscend, cSearch, lSoft, lLast )

local cSpace := space( 11 )

dbseek( cSearch, lSoft, lLast )
? cSpace, F1, recno(), "  No Filter"
If lAscend
   set filter to recno() < 9 .and. recno() != 2
else
   set filter to recno() > 2 .and. recno() != 9
endif
go top
dbseek( cSearch, lSoft, lLast )
If lAscend
   ? cSpace, F1, recno(), "  recno() < 9 .and. recno() != 2"
else
   ? cSpace, F1, recno(), "  recno() > 2 .and. recno() != 9"
endif
set filter to

return Nil

*+ EOF: CDX_LAST.PRG
